/*
 * XXX: (reg) insert final project name here.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Jeremy D. Lea
 * XXX: (reg) Insert date
 *
 * Based on pkg_install, by:
 *   Jordan K. Hubbard
 *   18 July 1993
 *
 * Message callback routines.
 */

#include <sys/param.h>
#include <stdarg.h>
#include <stdio.h>
#include "list.h"
#include "lib.h"

/*
 * Print out an important message.
 */
void
msg_note(const char *fmt, ...)
{
	va_list args;

	va_start(args, fmt);
	if (PkgMgr.msg != NULL)
		PkgMgr.msg(fmt, args);
	va_end(args);
}

/*
 * Print out a general message, conditional on verbose output.
 */
void
msg_verbose(const char *fmt, ...)
{
	va_list args;

	va_start(args, fmt);
	if (PkgMgr.msg != NULL && PkgMgr.verbose)
		PkgMgr.msg(fmt, args);
	va_end(args);
}

/*
 * Print out a warning message.
 */
void
msg_warn(const char *fmt, ...)
{
	va_list args;

	va_start(args, fmt);
	if (PkgMgr.warn != NULL)
		PkgMgr.warn(fmt, args);
	va_end(args);
}

/*
 * Print out an error message.  PkgMgr.error need not return, but if it
 * does, whoever called msg_error should try to exit ASAP.
 */
void
msg_error(int err, const char *fmt, ...)
{
	va_list args;

	va_start(args, fmt);
	if (PkgMgr.err != NULL)
		PkgMgr.err(err, fmt, args);
	va_end(args);
}
